%define distr_type sysyphus
%if "%{get_version xorg-x11-libs}" == "6.8.2"
%define distr_type compact30
%endif

%define tbname         NVIDIA-Linux-x86
%define virtualPkgName NVIDIA_GLX
%define binPkgName     nvidia_glx
%define module_name    nvidia
%define tbsuffix pkg0

# version-release
%define VERSION 1.0
%define RELEASE 8762
%define rel_prefix alt0.1.M30
%define rel_suffix .sisyphus
%if "%distr_type" == "compact30"
%define rel_suffix %nil
%endif
%define rel %rel_prefix%rel_suffix

%define verrel %{VERSION}-%{RELEASE}
%define module_version	%RELEASE
%define module_release	%rel

%define myGroup System/Kernel and hardware
%define mySummary NVIDIA drivers and OpenGL libraries for XFree86 4.x X-server
%define mySummaryRu Драйверы NVIDIA и библиотеки OpenGL для Х-сервера XFree86 4.x
%define myUrl http://www.nvidia.com
%define myVendor NVIDIA Corp.
%define myLicense NVIDIA

%define exts /modules/extensions
%define drvs /modules/drivers
%define nvlibdir %_x11libdir/nvidia_%VERSION.%RELEASE
%define syml_dir %_sysconfdir/X11/lib
%define nv_syml_dir %{syml_dir}_nvidia
%define syml_d %_sysconfdir/X11/drv.d
%define xdrv_d %_x11dir/lib/drv.d

%add_findreq_skiplist %_x11libdir/*.so*

Source: ftp://download.nvidia.com/XFree86/Linux-x86/%verrel/%tbname-%verrel-%tbsuffix.run
Source1: set_gl_nvidia-0.2.3.tar.gz

BuildRequires: kernel-build-tools XFree86-libs
ExclusiveArch: %ix86
#ExcludeArch: ppc64 x86_64 ppc s390 s390x ia64

Name: %{binPkgName}_src_%{VERSION}.%{RELEASE}
Version: %VERSION.%RELEASE
Release: %rel


Group: %myGroup
Summary: %mySummary
Summary(ru_RU.UTF-8): %mySummaryRu
Url: %myUrl
Vendor: %myVendor
License: %myLicense
%description
Sources for %{binPkgName}_%{version} package



%package -n %{binPkgName}_common
#Obsoletes: %virtualPkgName < %version-%release
Conflicts: xorg-x11-mesagl <= 6.8.2-alt7
#
Group: %myGroup
Summary: This is common package for usability NVIDIA drivers.
Summary(ru_RU.UTF-8): Пакет для совместимости драйверов NVIDIA.
Url: %myUrl
Vendor: %myVendor
License: %myLicense
#
%description -n %{binPkgName}_common
This is common package for NVIDIA drivers.
#
%description -n %{binPkgName}_common -l ru_RU.UTF-8
Этот пакет нужен для совместимости при отсутствии
одной из компонент драйверов для NVIDIA.



%package -n %{binPkgName}_%{version}
PreReq: %{binPkgName}_common >= %version
Requires(post,postun): x11setupdrv
#Requires: XFree86-server >= 4.0.3
#Requires: libGLwrapper
#Requires: NVIDIA_kernel = %version
#Provides: libGL
Provides: %virtualPkgName = %version-%release
Provides: x11-driver-nvidia = %version-%release
Obsoletes: %virtualPkgName < %version-%release
#
Group: %myGroup
Summary: %mySummary
Summary(ru_RU.UTF-8): %mySummaryRu
Url: %myUrl
Vendor: %myVendor
License: %myLicense
#
%description -n %{binPkgName}_%{version}
NVIDIA XFree86 4.x server drivers and OpenGL libraries for RIVA TNT/TNT2
and GeForce/Quadro based video cards.  Older RIVA 128 based video cards are
supported by the server module shipping with XFree86 4.x, nv_drv.o. You
should install this package if you have one of the newer cards.

You must also install the NVIDIA_kernel package if you want
NVIDIA module and OpenGL libraries for XFree86 4.x X server.
#
%description -n %{binPkgName}_%{version} -l ru_RU.UTF-8
Драйверы и OpenGL-библиотеки для Х-сервера XFree86 4.x и видеокарт NVIDIA
на базе RIVA TNT/TNT2 и GeForce/Quadro. Более ранние версии видеокарт на базе
RIVA 128 поддерживаются модулем nv_drv.o, входящим в состав сервера XFree86 4.x.
Если вы имеете одну из этих новых видеокарт, то вам желательно установить данный
пакет.

Если вы желаете использовать модули NVIDIA и библиотеки OpenGL для Х-сервера XFree86 4.0,
то вы должны также установить пакет NVIDIA_kernel.

%package -n kernel-source-%module_name-%module_version
Group: Development/Kernel
Summary: Linux %module_name modules sources
Vendor: %myVendor
License: %myLicense
Packager: Kernel Maintainer Team <kernel@packages.altlinux.org>
#
%description -n kernel-source-%module_name-%module_version
%module_name modules sources for Linux kernel

%package -n %{binPkgName}-devel
Group: Development/C
Summary: Development files for NVIDIA OpenGL
Vendor: %myVendor
License: %myLicense
#
%description -n %{binPkgName}-devel
Development files for NVIDIA OpenGL

%prep
%setup -T -c -n %tbname-%verrel-%tbsuffix
rm -rf %_builddir/%tbname-%verrel-%tbsuffix
cd %_builddir
sh %SOURCE0 -x
cd %tbname-%verrel-%tbsuffix
tar xvfz %SOURCE1
pushd set_gl_nvidia*
cp settings.h.in settings.h
subst "s|@DEFAULT_VERSION@|%version|" settings.h
subst "s|@SYML_DIR@|%syml_dir|" settings.h
subst "s|@NV_SYML_DIR@|%nv_syml_dir|" settings.h
subst "s|@TLS_LIB_DIR@|%_libdir/tls|" settings.h
subst "s|@LIB_DIR@|%_libdir|" settings.h
subst "s|@XLIB_DIR@|%_x11libdir|" settings.h
subst "s|@XDRV_DIR@|%_x11libdir%drvs|" settings.h
subst "s|@XEXT_DIR@|%_x11libdir%exts|" settings.h
subst "s|@DRV_DIR_PREFIX@|%_x11libdir/nvidia_|" settings.h
popd

pushd usr/src/nv/
%__rm -rf precompiled
popd


%build
%if "%distr_type" == "compact30"
%add_optflags -DDONT_RESTORE_NEW_LIBGLX
%endif
make OPTFLAGS="%optflags" -C set_gl_nvidia*
strip set_gl_nvidia*/nvidia
>nvidianull.c
gcc %optflags -c nvidianull.c -o nvidianull.o
ld --shared nvidianull.o -o libnvidianull.so
strip libnvidianull.so

%install
%set_verify_elf_method textrel=relaxed
%set_strip_method none
%add_findprov_lib_path %nvlibdir

soname()
{
    readelf -a $1| grep SONAME| sed 's/.*\[//'| sed 's/\].*//'
}

%__mkdir_p %buildroot/%_sbindir
%__mkdir_p %buildroot/%_x11libdir
%__mkdir_p %buildroot/%nvlibdir
%__mkdir_p %buildroot/%xdrv_d
%__mkdir_p %buildroot/%syml_d

%__install -m 0755 set_gl_nvidia*/nvidia %buildroot/%xdrv_d/nvidia
%__ln_s ../../..%xdrv_d/nvidia %buildroot/%syml_d/nvidia

%__install -m 0755 libnvidianull.so %buildroot/%_x11libdir/

%__install -m 0644 usr/X11R6/lib/%drvs/nvidia_drv.o      %buildroot/%nvlibdir/
[ -f usr/X11R6/lib/%drvs/nvidia_drv.so ] && \
%__install -m 0644 usr/X11R6/lib/%drvs/nvidia_drv.so      %buildroot/%nvlibdir/

%__install -m 0644 usr/X11R6/lib/%exts/libglx.so.%version %buildroot/%nvlibdir/libglx.so
%__ln_s libglx.so %buildroot/%nvlibdir/libglx.a

%__install -m 0644 usr/lib/libGL.so.%version  %buildroot/%nvlibdir/libGL.so

%__install -m 0644 usr/lib/libGLcore.so.%version %buildroot/%nvlibdir/libGLcore.so

%__install -m 0644 usr/X11R6/lib/libXvMCNVIDIA.so.%version %buildroot/%nvlibdir/libXvMCNVIDIA.so
%__ln_s libXvMCNVIDIA.so %buildroot/%nvlibdir/libNVIDIAXvMC.so

%__install -m 0644 usr/lib/libnvidia-tls.so.%version %buildroot/%nvlibdir/libnvidia-tls.so
%__install -m 0644 usr/bin/tls_test %buildroot/%nvlibdir/tls_test
%__install -m 0644 usr/bin/tls_test_dso.so %buildroot/%nvlibdir/tls_test_dso.so

/sbin/ldconfig -n %buildroot/%nvlibdir

%__mkdir_p %buildroot/%_x11libdir/modules/{drivers,extensions}/
%__mkdir_p %buildroot/%nv_syml_dir
%__mkdir_p %buildroot/%_libdir/tls

%__ln_s ../../..%_x11libdir/libnvidianull.so %buildroot/%nv_syml_dir/nvidia_drv.o
%__ln_s ../../..%_x11libdir/libnvidianull.so %buildroot/%nv_syml_dir/nvidia_drv.so
%__ln_s ../../..%_x11libdir/libnvidianull.so %buildroot/%nv_syml_dir/`soname %buildroot/%nvlibdir/libGLcore.so`
%__ln_s ../../..%_x11libdir/libnvidianull.so %buildroot/%nv_syml_dir/`soname %buildroot/%nvlibdir/libNVIDIAXvMC.so`
%__ln_s ../../..%_x11libdir/libnvidianull.so %buildroot/%nv_syml_dir/libNVIDIAXvMC.so
%__ln_s ../../..%_x11libdir/libnvidianull.so %buildroot/%nv_syml_dir/`soname %buildroot/%nvlibdir/libnvidia-tls.so`

%__ln_s ../../../../..%nv_syml_dir/nvidia_drv.o \
    %buildroot/%_x11libdir/modules/drivers/nvidia_drv.o
%__ln_s ../../../../..%nv_syml_dir/nvidia_drv.so \
    %buildroot/%_x11libdir/modules/drivers/nvidia_drv.so
%__ln_s ../../..%nv_syml_dir/`soname %buildroot/%nvlibdir/libGLcore.so` \
    %buildroot/%_x11libdir/`soname %buildroot/%nvlibdir/libGLcore.so`
%__ln_s ../../..%nv_syml_dir/`soname %buildroot/%nvlibdir/libNVIDIAXvMC.so` \
    %buildroot/%_x11libdir/`soname %buildroot/%nvlibdir/libNVIDIAXvMC.so`
%__ln_s ../../..%nv_syml_dir/libNVIDIAXvMC.so \
    %buildroot/%_x11libdir/libNVIDIAXvMC.so
%__ln_s ../..%nv_syml_dir/`soname %buildroot/%nvlibdir/libnvidia-tls.so` \
    %buildroot/%_libdir/`soname %buildroot/%nvlibdir/libnvidia-tls.so`

# kernel-source install
%__rm -rf kernel-source-%module_name-%module_version/
%__mkdir_p %buildroot/%_usrsrc/kernel/sources/ kernel-source-%module_name-%module_version/
%__cp -ar usr/src/nv/* kernel-source-%module_name-%module_version/
%__cp LICENSE kernel-source-%module_name-%module_version/
tar -c kernel-source-%module_name-%module_version | bzip2 -c > \
    %buildroot%_usrsrc/kernel/sources/kernel-source-%module_name-%module_version.tar.bz2

# install headers
%__mkdir_p %buildroot/%_includedir/nvidia
%__cp -ar usr/include/GL %buildroot/%_includedir/nvidia

%post -n %{binPkgName}_%{version}
if [ -z "$DURING_INSTALL" ]; then
    NV_KERN_VER_FILE=/%_lib/modules/`uname -r`/.versions/nvidia
    if [ -f $NV_KERN_VER_FILE ]; then
	REQ_VER="%version"
	NV_KERN_VER=`cat $NV_KERN_VER_FILE`
	if [ "$NV_KERN_VER" == "$REQ_VER" ]; then
	    X11SETUPDRV=`which x11setupdrv 2>/dev/null`
	    if [ -n "$X11SETUPDRV" ]; then
		$X11SETUPDRV ||:
	    else
		echo "Warning! x11setupdrv program not found!" >&2
	    fi
	else
	    echo "Warning! Required nvidia kernel version is $REQ_VER" >&2
	    echo "but found $NV_KERN_VER :-(" >&2
	fi
    else
	echo "Warning! $NV_KERN_VER_FILE not found" >&2
    fi
fi
%post_ldconfig
%postun -n %{binPkgName}_%{version}
X11SETUPDRV=`which x11setupdrv 2>/dev/null`
if [ -n "$X11SETUPDRV" ]; then
    $X11SETUPDRV ||:
else
    echo "Warning! x11setupdrv program not found!" >&2
fi
%postun_ldconfig

%post -n %{binPkgName}_common
%postun -n %{binPkgName}_common

%files -n %{binPkgName}_%{version}
%doc LICENSE
%doc usr/share/doc/*
%doc usr/include
#
%defattr (0555, root, root)
#
%dir %nvlibdir
%nvlibdir/nvidia_drv.o
%nvlibdir/nvidia_drv.so
%nvlibdir/libglx.a
%nvlibdir/libglx.so
%nvlibdir/libGL.so*
%nvlibdir/libGLcore.so*
%nvlibdir/lib*XvMC*.so*
%nvlibdir/libnvidia-tls.so*
%nvlibdir/tls_test*

%files -n %{binPkgName}_common
%dir %xdrv_d/
%xdrv_d/nvidia
%dir %syml_d/
%syml_d/nvidia
%_x11libdir/libnvidianull.so
%dir %nv_syml_dir/
#
%nv_syml_dir/nvidia_drv.o
%_x11libdir/%drvs/nvidia_drv.o
#
%nv_syml_dir/nvidia_drv.so
%_x11libdir/%drvs/nvidia_drv.so
#
%nv_syml_dir/libGLcore.so.?
%_x11libdir/libGLcore.so.?
#
%nv_syml_dir/libXvMCNVIDIA_dynamic.so.?
%_x11libdir/libXvMCNVIDIA_dynamic.so.?
#
%nv_syml_dir/libNVIDIAXvMC.so
%_x11libdir/libNVIDIAXvMC.so
#
%nv_syml_dir/libnvidia-tls.so.?
%_libdir/libnvidia-tls.so.?

%files -n %{binPkgName}-devel
%_includedir/nvidia

%files -n kernel-source-%module_name-%module_version
%_usrsrc/*

%changelog
* Fri Jun 23 2006 Sergey V Turchin <zerg at altlinux dot org> 1.0.8762-alt0.1.M30
- built for M30

* Tue Apr 11 2006 Sergey V Turchin <zerg at altlinux dot org> 1.0.8756-alt0.1.M30%rel_suffix
- built for M30

* Thu Aug 25 2005 Sergey V Turchin <zerg at altlinux dot org> 1.0.7676-alt14%rel_suffix
- dont restore libglx.so for Compact-3.0

* Thu Aug 18 2005 Sergey V Turchin <zerg at altlinux dot org> 1.0.7676-alt13
- symlink /etc/X11/lib_nvidia/nvidia_drv.* to existing file again

* Wed Aug 17 2005 Sergey V Turchin <zerg at altlinux dot org> 1.0.7676-alt12
- new version

* Mon Aug 08 2005 Sergey V Turchin <zerg at altlinux dot org> 1.0.7667-alt11
- new version

* Mon Aug 08 2005 Sergey V Turchin <zerg at altlinux dot org> 1.0.7174-alt10
- add libglx.so
- turn off verbosity of /usr/X11R6/lib/drv.d/nvidia by default
  (added command line options)

* Wed Jul 06 2005 Sergey V Turchin <zerg at altlinux dot org> 1.0.7174-alt9
- fix path to .versions/nvidia in %%post

* Thu Jun 30 2005 Sergey V Turchin <zerg at altlinux dot org> 1.0.7174-alt8
- change setgl to x11setupdrv in %%post
- symlink /etc/X11/lib_nvidia/nvidia_drv.* to unexisting file by default

* Tue Jun 14 2005 Sergey V Turchin <zerg at altlinux dot org> 1.0.7174-alt7
- add symlink libnvidia-tls.so.1 to /usr/lib
- do not check for tls in /usr/X11R6/lib/nvidia
- restore symlinks for libglx.a and libGL.so.1 in /usr/X11R6/lib if absent

* Fri Jun 10 2005 Sergey V Turchin <zerg at altlinux dot org> 1.0.7174-alt6
- move writable symlinks to %nv_syml_dir
- add check for tls to link libnvidia-tls.so correctly

* Tue Jun 07 2005 Sergey V Turchin <zerg at altlinux dot org> 1.0.7174-alt5
- new x11 driver switch system; %xdrv_d/nvidia adjust the driver

* Fri Apr 29 2005 Sergey V Turchin <zerg at altlinux dot org> 1.0.7174-alt4
- fix provides for X configurator

* Thu Apr 07 2005 Sergey V Turchin <zerg at altlinux dot org> 1.0.7174-alt3
- add kernel-source-nvidia subpackage

* Wed Apr 06 2005 Sergey V Turchin <zerg at altlinux dot org> 1.0.7174-alt2
- fix nvidia_set_glx

* Mon Apr 04 2005 Sergey V Turchin <zerg at altlinux dot org> 1.0.7174-alt1
- new version

* Tue Mar 15 2005 Sergey V Turchin <zerg at altlinux dot org> 1.0.7167-alt1
- new version
- service start after network by default

* Mon Nov 22 2004 Sergey V Turchin <zerg at altlinux dot org> 1.0.6629-alt1
- new version

* Fri Oct 08 2004 Sergey V Turchin <zerg at altlinux dot org> 1.0.6111-alt2
- try to fix link to libGL.so.1 when service nvidia_glx starts

* Fri Aug 06 2004 Sergey V Turchin <zerg at altlinux dot org> 1.0.6111-alt1
- new version

* Mon Jul 19 2004 Sergey V Turchin <zerg at altlinux dot org> 1.0.6106-alt4
- ignore non-NVIDIA videocards via pciscan in initscript

* Tue Jul 13 2004 Sergey V Turchin <zerg at altlinux dot org> 1.0.6106-alt3
- add %%ghost files to -common package

* Fri Jul 02 2004 Sergey V Turchin <zerg at altlinux dot org> 1.0.6106-alt2
- fix libnvidia-tls.so.1 link placement

* Fri Jul 02 2004 Sergey V Turchin <zerg at altlinux dot org> 1.0.6106-alt1
- new version

* Tue Feb 03 2004 Sergey V Turchin <zerg at altlinux dot org> 1.0.5336-alt1
- new version

* Mon Jan 19 2004 Sergey V Turchin <zerg at altlinux dot org> 1.0.5328-alt2
- initscript compatible with 2.6.x kernels
- add start on 3,4 runlevels

* Tue Dec 23 2003 Sergey V Turchin <zerg at altlinux dot org> 1.0.5328-alt1
- new version

* Tue Dec 23 2003 Sergey V Turchin <zerg at altlinux dot org> 1.0.4496-alt7
- fix initscript status message

* Thu Oct 30 2003 Sergey V Turchin <zerg at altlinux dot org> 1.0.4496-alt6
- fix initscript fail message

* Fri Sep 26 2003 Sergey V Turchin <zerg at altlinux dot org> 1.0.4496-alt5
- fix %%post

* Fri Sep 26 2003 Sergey V Turchin <zerg at altlinux dot org> 1.0.4496-alt4
- force install service nvidia_lgx when variable DURING_INSTALL=1

* Mon Sep 15 2003 Sergey V Turchin <zerg at altlinux dot org> 1.0.4496-alt3
- fix initscript

* Mon Sep 15 2003 Sergey V Turchin <zerg at altlinux dot org> 1.0.4363-alt2
- make possible to install different versions together

* Wed Jul 30 2003 Sergey V Turchin <zerg at altlinux dot org> 1.0.4496-alt1
- new version

* Tue Jul 01 2003 Sergey V Turchin <zerg at altlinux dot org> 1.0.4363-alt1
- new version

* Tue May 06 2003 Sergey V Turchin <zerg at altlinux dot ru> 1.0.4349-alt2
- remove requires to XFree86-server libGLwrapper
- remove very old versions from %%versions

* Wed Apr 02 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.4349-alt1
- New upstream version

* Sun Feb 16 2003 Aleksandr Blokhin 'Sass' <sass@altlinux.ru> 1.0.4191-alt3
- Fixed file permissions on %%doc
- Added Summary and %%description in Russian

* Fri Dec 20 2002 Sergey V Turchin <zerg@altlinux.ru> 1.0.4191-alt2
- fix link to %xlibdir/%exts/libglx.so

* Thu Dec 19 2002 Sergey V Turchin <zerg@altlinux.ru> 1.0.4191-alt1
- new version

* Fri Sep 13 2002 Konstantin Volckov <goldhead@altlinux.ru> 1.0.3123-alt1
- new version

* Thu Jun 06 2002 Konstantin Volckov <goldhead@altlinux.ru> 1.0.2960-alt1
- new version

* Fri Mar 15 2002 Sergey V Turchin <zerg@altlinux.ru> 1.0.2802-alt1
- new version

* Fri Feb 22 2002 Sergey V Turchin <zerg@altlinux.ru> 1.0.2313-alt1
- prepare for Sisyphus

* Thu Jan 31 2002 Sergey V Turchin <zerg@altlinux.ru> ALL-alt2
- fix requires
- cleanup spec

* Tue Jan 29 2002 Sergey V Turchin <zerg@altlinux.ru> ALL-alt1
- add interactive build

* Sat Dec 29 2001 Ivan Zakharyaschev <imz@altlinux.ru> 1.0.2313-alt3
- fix requires version (add 1.0 prefix)

* Tue Dec 18 2001 Konstantin Volckov <goldhead@altlinux.ru> 1.0.2313-alt2
- Fixed requires as kernel_version of this driver is 2314

* Wed Dec 05 2001 Sergey V Turchin <zerg@altlinux.ru> 1.0.2313-alt1
- new version

* Thu Jun 14 2001 Sergey V Turchin <zerg@altlinux.ru> 1.0.1251-alt5
- changed pakage name to nvidiaGL

* Fri Jun 08 2001 Sergey V Turchin <zerg@altlinux.ru> 1.0.1251-alt4
- fix requires

* Wed May 23 2001 Sergey V Turchin <zerg@altlinux.ru>
- first build
